import importlib
import logging

logger = logging.getLogger(__name__)

TASKS = ["install_os", "setup_os", "debconf", "install_database",
         "install_drivers", "install_extras", "install_platform", "install_features",
         "remove_legacy_platform", "register", "setup_user", "update_platform",
         "remove_platform", "unregister", "remove_data", "nuke", "afterinstall_checks",
         "check_updates", "register_extra", "restore_backup", "install_cranium",
         "get_registration_info", "remove_user", "remount"]

class Task (object):
    def __init__ (self, name, module):
        self._name = name
        self._module = module

    def __call__ (self, *args, **kwargs):
        logger.info("Running task: {}".format(self._name))
        return self._module.__call__(*args, **kwargs)

for task_name in TASKS:
    vars()[task_name] = Task(task_name, importlib.import_module(".{}".format(task_name), package=__name__))
