import logging

#from ..context import Context

logger = logging.getLogger(__name__)

class Select (object):
    def __init__ (self, value):
        self.value = value

class MultiSelect (object):
    def __init__ (self, *values):
        self.values = values

class Password (object):
    def __init__ (self, value):
        self.value = value

PRESEED_VARS = {
    "d-i": {
        "debian-installer/locale": "en_US",
        "time/zone": "US/Eastern",
        
        "partman-auto/method": "regular",
        "partman/confirm_write_new_label": True,
        "partman/choose_partition": Select("finish"),
        "partman/confirm": True,
        "partman/confirm_nooverwrite": True,
        
        "passwd/user-fullname": "Cattura",
        "passwd/username": "cattura",
        "passwd/user-password": Password("c@ttur@"),
        "passwd/user-password-again": Password("c@ttur@"),
        "user-setup/allow-password-weak": True
    },
    
    "tasksel": {
        "tasksel/first": MultiSelect("standard")
    }
}

def __call__ (config):
    pass

def preseed_to_string (preseed):
    entries = []
    for key, group in preseed.iter_items():
        for subkey, value in group.iter_items():
            type = type(value).__name__.tolower()
            if isinstance(value, str):
                type = "string"
            elif isinstance(value, bool):
                type = "boolean"
                value = str(value).lower()
            elif isinstance(value, Select) or isinstance(value, Password):
                value = value.value
            elif isinstance(value, MultiSelect):
                value = ", ".join(value.values)
            
            entries.append("{} {} {} {}".format(
                key,
                subkey,
                type,
                value
            ))
    return "\n".join(entries)