import unittest
import sys
import installer

class TestInstaller (unittest.TestCase):
    def test_installer (self):
        installer.main(["--dry", "--logfile", "test.log"])
    
    def test_installer_uninstall (self):
        installer.main(["--dry", "--uninstall", "--logfile", "test-uninstall.log"])
    
    def test_installer_wipe (self):
        installer.main(["--dry", "--wipe-data", "--yes", "--logfile", "test-wipe.log"])
    
    def test_installer_nuke (self):
        installer.main(["--dry", "--nuke", "--yes", "--logfile", "test-nuke.log"])
    
    def test_installer_selected_publishers (self):
        installer.main(["--dry", "--install", "--publishers", "kaltura", "youtube", "--logfile", "test-publishers.log"])
    
    def test_installer_features (self):
        installer.main(["--dry", "--install", "--features", "editing-station", "--logfile", "test-features.log"])
    
    def test_installer_restore (self):
        installer.main(["--dry", "--install", "--restore-from", "foo.tar", "--logfile", "test-restore-from.log"])
    
    def test_installer_register (self):
        installer.main(["--dry", "--register", "--logfile", "test-register.log"])
    
    def test_installer_unregister (self):
        installer.main(["--dry", "--unregister", "--logfile", "test-unregister.log"])
    
    def test_installer_wipe_uninstall (self):
        installer.main(["--dry", "--wipe", "--uninstall", "--yes", "--logfile", "test-wipe-uninstall.log"])
    
    def test_installer_install_command_center (self):
        installer.main(["--dry", "--install-command-center", "--logfile", "test-install-command-center.log"])
    
    def test_installer_help (self):
        with self.assertRaises(SystemExit):
            installer.main(["--help"])