from __future__ import print_function
import unittest
from uuid import uuid1 as uuid
from installer.cranium import Cranium

CRANIUM_URL = "http://localhost:8001/"
CRANIUM_USER_TOKEN = "9c0hdpignv9hjfqs54zrm3bot8sqrbyv"
CRANIUM_UNIT_TOKEN = "h845zu770712bxzng6sa6bmjcdcx5luj"

@unittest.skip
class TestCranium (unittest.TestCase):
    def test_cranium_info (self):
        cranium = Cranium(CRANIUM_URL)
        print(cranium.info())

    def test_cranium_user_token (self):
        cranium = Cranium(CRANIUM_URL, token=CRANIUM_USER_TOKEN)
        print(cranium.get_user("me"))

    def test_cranium_unit_token (self):
        cranium = Cranium(CRANIUM_URL, token=CRANIUM_UNIT_TOKEN)
        print(cranium.get_unit("me"))

    def test_cranium_registration_procedure (self):
        cranium = Cranium(CRANIUM_URL, token=CRANIUM_USER_TOKEN)
        
        # create unit
        unit = cranium.add_unit({
            "url": "http://beta.catturavideo.com/"
        }, unit_id=str(uuid()))
        print(unit)

        # create token for unit
        token = cranium.add_unit_token(unit["id"])["inboundAccessToken"]
        self.assertTrue(token)
        print(token)

        # authenticate with token as unit
        self.assertEqual(Cranium(CRANIUM_URL, token=token).get_unit("me")["id"], unit["id"])

        # remove unit
        print(cranium.remove_unit(unit["id"]))